//#########################################################//
/* ------------------------------------------------------- */
/* ------------ Instant Message User In Grid  ------------- */
/* ------------------------------------------------------- */
// Tested with portal v7.2.2012
// Modified from Martin Blomgren's Assign to Me from Grid Task
// https://community.cireson.com/discussion/1919/custom-quick-assign-work-item-to-me-from-grid
// Description: Instant Message users from Grid View and pull Skype/Lync
//v0.1 =  Adds Skype icon next to Affected Users in grid view


(function() { // Avoid Global variables where we can!
    $(document).ready(function () {
        if (session.user.Analyst === 0) {
            console.log("AssignToMeInGrid: User is not Analyst, exiting...");
            return;
        }

        var url = window.location.href;
        // Verify we are on My Work, Team Work or Active work page with a gridview.
        if(url.indexOf("cca5abda-6803-4833-accd-d59a43e2d2cf") > -1 || url.indexOf("f94d43eb-eb42-4957-8c48-95b9b903c631") > -1 || url.indexOf("62f452d5-66b5-429b-b2b1-b32d5562092b") > -1 )
		{ 
            //The navigation node doesn't load immediately. Get the main div that definitely exists.
            var mainPageNode = document.getElementById('main_wrapper');
            
            // create an observer instance
            var assignToMeObserver = new MutationObserver(function(mutations) {
                //The page changed. See if our title exists. If it does, then our gridview should also exist.
                var titleElement = $(".page_title"); //The title always exists. If this page has a gridview, then it also exists as soon as the title does.
                
                if (titleElement.length > 0) { //An element with class of page_title exists.
                    var gridElement = $('[data-role=grid]') // Get the grid object
                    if (gridElement.length > 0) {
                        AddAssignEventHandlersOnGridDataSourceChange(gridElement);
                    }
                    
                    //We are done observing.
                    assignToMeObserver.disconnect();
                }
                
            });
            
            // configure the observer and start the instance.
            var observerConfig = { attributes: true, childList: true, subtree: true, characterData: true };
            assignToMeObserver.observe(mainPageNode, observerConfig);
        }
    });

    var AddAssignEventHandlersOnGridDataSourceChange = function(gridElement) {

        var kendoGridElement = gridElement.data('kendoGrid'); //...as a kendo widget
        
        //Whenever the data changes, add assign button again.
        kendoGridElement.bind("dataBound", AddAssignEventHandlers); 
        //Note to self. the dataBound fires after the rows are returned, and dataBinding fires before. 
    }

    var AddAssignEventHandlers = function() {
        //find column index with assigned user
        $('thead > tr > th').each(function(index) {
            if ($(this).data().field == "AffectedUser") {
                // add assign to me button
                $('tbody > tr').each(function(index2) {
                    //Don't add button to Review Activities
                    if (!($(this).children('td').eq(1).text().indexOf("RA") > -1))
					{
                        var affectedElem = $(this).children('td').eq(index);
                        if ((!(affectedElem.text() == "")) && (!(affectedElem.text() == session.user.Name)))
						{              
                            affectedElem.append('<a onclick="InstantMessageAU(this)" title="Instant Message" class="pull-right"><img src="/CustomSpace/instantMessageAffectedUser/skypeIcon.png" /></a>');
                        }                   
                    }
                    
                })

                return false;
            }
        });
    }
})(); // the parentese here cause the anonymous function to execute and return

// fired when user presses on assign to me button
var InstantMessageAU = function(e)
{
    // Get workitem Id
    var workItemId = $(e).parent().prev().prev().prev().prev().prev().prev().prev().text();

    // Get projection type id
    var projectionTypeId;
    if (workItemId.indexOf("IR") >= 0) {
        projectionTypeId = "2d460edd-d5db-bc8c-5be7-45b050cba652";
    } else if (workItemId.indexOf("SR") >= 0) {
        projectionTypeId = "7ffc8bb7-2c2c-0bd9-bd37-2b463a0f1af7";
    } else if (workItemId.indexOf("CR") >= 0) {
        projectionTypeId = "4C8F4F06-4C8F-A1B6-C104-89CFB7B593FA";
    } else if (workItemId.indexOf("PR") >= 0) {
        projectionTypeId = "AA6D17AC-0ED8-5D86-D862-CFF4CD8792FA";
    } else if (workItemId.indexOf("RR") >= 0) {
    	projectionTypeId = "556e527e-893c-61fa-5663-49d9944fccbd";
    } else if (workItemId.indexOf("RA") >= 0) {
        projectionTypeId = "3043253C-959E-25BD-32B4-C5EB1A7E71DC";
    }  else if (workItemId.indexOf("MA") >= 0) {
        projectionTypeId= "953BEAEE-ACF8-A195-363D-4782B2F919AC"
    }
	
	// Get work item
    $.getJSON('/api/V3/Projection/GetProjection', 
    { 
    "id": workItemId,
    "typeProjectionId": projectionTypeId 
    }, 
    function (data) {
        // Copy work item so we can make changes
        var newData = $.parseJSON(JSON.stringify(data));
		window.location.href = "sip:" + newData.RequestedWorkItem.UPN
	});
};

/* ------------------------------------------------------- */
/* --------- Instant Message User In Grid  ------------ */
/* ------------------------------------------------------- */
